<template>
  <div>

    <div class="template account" >
      <div class="accountElement userImage">
        <img
          class="userImageImg"
          v-if="account.urlImage"
          :src="account.urlImage"
          alt="Photo de l'utilisateur"
        />
        <img
          class="userImageImg"
          v-else
          src="../assets/images/user.png"
          alt="icone représentant un utilisatuer en l'absence de photo"
        />
      </div>

      <div class="accountElement firstName">
        <p class="accountElementTitle">Prénom</p>
        <p class="accountElementData">{{ account.firstName }}</p>
      </div>
      <div class="accountElement lastName">
        <p class="accountElementTitle">Nom</p>
        <p class="accountElementData">{{ account.lastName }}</p>
      </div>
      <div class="accountElement email">
        <p class="accountElementTitle">email</p>
        <p class="accountElementData">{{ account.email }}</p>
      </div>
      <div class="accountElement deleteButton">
        <button id="delete" type="submit" @click="deleteAccount">
          Supprimer mon compte
        </button>
      </div>
    </div>
    
  </div>
</template>

<script>
import axios from "axios";
import { mapState } from "vuex";


export default {
  name: "AccountView",
  components: {

  },
  data() {
    return {
      existAccount: true,
      account: [],

    };
  },
  computed: {
    ...mapState(["status", "user"]),
  },

  //Redirection vers login si non connecté
  mounted() {
    if (this.$store.state.user.userId == -1) {
      this.$router.push("/login");
      return;
    }
  },
  created() {
    let id = this.$store.state.user.userId;
    const token = this.$store.state.user.token;

    axios
      .get(`http://localhost:3000/api/users/${id}`, {
        headers: {
          Authorization: `Basic ${token}`,
        },
      })
      .then((response) => {
        this.account = response.data;
      })
      .catch((error) => {
        console.log(error);
      });

    axios
      .get("http://localhost:3000/api/users", {
        headers: {
          Authorization: `Basic ${token}`,
        },
      })
      .then((response) => {
        this.accountUsers = response.data;
      })
      .catch((error) => {
        console.log(error);
      });
  },
  methods: {
    deleteAccount() {
      let id = this.$store.state.user.userId;
      const token = this.$store.state.user.token;
      if (
        window.confirm(
          "Voulez-vous supprimez ce compte ? Cette opération est irreversible. Vos posts et commentaires seront supprimés"
        )
      ) {
        axios
          .delete(`http://localhost:3000/api/users/delete/${id}`, {
            headers: {
              Authorization: `Basic ${token}`,
            },
          })
          .then(() => {
            this.existAccount = false;
            this.$store.commit("logout");
            this.$store.commit("setStatus", "");
            alert("Votre compte est supprimé.");
            this.$router.push("/");
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.template {
  background-image: url("../assets/logos/icon.svg");
  background-attachment: fixed;
  background-repeat: no-repeat;
  background-position: left;
}
.account {
  font-size: large;
  text-align: start;
  &Element {
    display: grid;
    grid-template-columns: 1fr 2fr;
    grid-column-gap: 10px;
    margin: 10px;
    padding: 20px;
    &Title {
      font-weight: bold;
    }
    &Data {
      font-style: italic;
    }
  }
}
.userImage {
  display: inline-block;
  position: relative;
  width: 100px;
  height: 100px;
  border-radius: 50%;
  &Img {
    border-radius: 50%;
    width: auto;
    height: 100%;
    object-fit: cover;
  }
}

button {
  border-radius: 40px;
  border: solid 1px blue;
  width: 300px;
  height: 50px;
  font-size: large;
  padding: 10px 20px;
  margin: auto;
  background-color: transparent;

  &:hover {
    font-weight: bold;
    color: white;
    background-color: red;
    border: none;
  }
}
@media screen and (max-width: 660px) {
  .template {
    padding-top: 150px;
  }
  .account {
    &Element {
      grid-template-columns: 1fr 2fr;
      grid-column-gap: 0px;
      margin: 20px;
      padding: 10px;
    }
  }
}
</style>
